<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_image_histogram.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
<h1>vx_tutorial_image_histogram.c</h1><a href="vx__tutorial__image__histogram_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">*</span>
<a name="l00003"></a>00003 <span class="comment">* Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00004"></a>00004 <span class="comment">*</span>
<a name="l00005"></a>00005 <span class="comment">* All rights reserved not granted herein.</span>
<a name="l00006"></a>00006 <span class="comment">*</span>
<a name="l00007"></a>00007 <span class="comment">* Limited License.</span>
<a name="l00008"></a>00008 <span class="comment">*</span>
<a name="l00009"></a>00009 <span class="comment">* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00010"></a>00010 <span class="comment">* license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00011"></a>00011 <span class="comment">* have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00012"></a>00012 <span class="comment">* terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00013"></a>00013 <span class="comment">* solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00014"></a>00014 <span class="comment">* The patent license shall not apply to any combinations which include this software,</span>
<a name="l00015"></a>00015 <span class="comment">* other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00016"></a>00016 <span class="comment">* No hardware patent is licensed hereunder.</span>
<a name="l00017"></a>00017 <span class="comment">*</span>
<a name="l00018"></a>00018 <span class="comment">* Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00019"></a>00019 <span class="comment">* (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00020"></a>00020 <span class="comment">* code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00021"></a>00021 <span class="comment">* with the distribution</span>
<a name="l00022"></a>00022 <span class="comment">*</span>
<a name="l00023"></a>00023 <span class="comment">* Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00024"></a>00024 <span class="comment">* that the following conditions are met:</span>
<a name="l00025"></a>00025 <span class="comment">*</span>
<a name="l00026"></a>00026 <span class="comment">* *       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00027"></a>00027 <span class="comment">* permitted with respect to any software provided in binary form.</span>
<a name="l00028"></a>00028 <span class="comment">*</span>
<a name="l00029"></a>00029 <span class="comment">* *       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00030"></a>00030 <span class="comment">*</span>
<a name="l00031"></a>00031 <span class="comment">* *       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00032"></a>00032 <span class="comment">* licensed and provided to you in object code.</span>
<a name="l00033"></a>00033 <span class="comment">*</span>
<a name="l00034"></a>00034 <span class="comment">* If software source code is provided to you, modification and redistribution of the</span>
<a name="l00035"></a>00035 <span class="comment">* source code are permitted provided that the following conditions are met:</span>
<a name="l00036"></a>00036 <span class="comment">*</span>
<a name="l00037"></a>00037 <span class="comment">* *       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00038"></a>00038 <span class="comment">* works, are licensed by TI for use only with TI Devices.</span>
<a name="l00039"></a>00039 <span class="comment">*</span>
<a name="l00040"></a>00040 <span class="comment">* *       any redistribution and use of any object code compiled from the source code</span>
<a name="l00041"></a>00041 <span class="comment">* and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00042"></a>00042 <span class="comment">*</span>
<a name="l00043"></a>00043 <span class="comment">* Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00044"></a>00044 <span class="comment">*</span>
<a name="l00045"></a>00045 <span class="comment">* may be used to endorse or promote products derived from this software without</span>
<a name="l00046"></a>00046 <span class="comment">* specific prior written permission.</span>
<a name="l00047"></a>00047 <span class="comment">*</span>
<a name="l00048"></a>00048 <span class="comment">* DISCLAIMER.</span>
<a name="l00049"></a>00049 <span class="comment">*</span>
<a name="l00050"></a>00050 <span class="comment">* THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00051"></a>00051 <span class="comment">* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00052"></a>00052 <span class="comment">* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00053"></a>00053 <span class="comment">* IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00054"></a>00054 <span class="comment">* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00055"></a>00055 <span class="comment">* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00056"></a>00056 <span class="comment">* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00057"></a>00057 <span class="comment">* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00058"></a>00058 <span class="comment">* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00059"></a>00059 <span class="comment">* OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00060"></a>00060 <span class="comment">*</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00109"></a>00109 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00110"></a>00110 <span class="preprocessor">#include &lt;VX/vx.h&gt;</span>
<a name="l00111"></a>00111 <span class="preprocessor">#include &lt;TI/tivx.h&gt;</span>
<a name="l00112"></a>00112 <span class="preprocessor">#include &lt;<a class="code" href="utility_8h.html">utility.h</a>&gt;</span>
<a name="l00113"></a>00113 
<a name="l00115"></a><a class="code" href="vx__tutorial__image__histogram_8c.html#a8118656bb5a60090a1dbffa402168438">00115</a> <span class="preprocessor">#define IN_FILE_NAME       &quot;colors.bmp&quot;</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>
<a name="l00118"></a><a class="code" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">00118</a> <span class="preprocessor">#define OUT_FILE_NAME      &quot;vx_tutorial_image_histogram_out.bmp&quot;</span>
<a name="l00119"></a>00119 <span class="preprocessor"></span>
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 vx_image <a class="code" href="vx__tutorial__image__histogram_8c.html#ae444e5c191e73db9a523c43b76a7478c" title="Convert distribution given as input to image.">convert_distribution_to_image</a>(vx_distribution distribution,
<a name="l00122"></a>00122             uint32_t width, uint32_t height);
<a name="l00123"></a>00123 
<a name="l00127"></a><a class="code" href="vx__tutorial__image__histogram_8c.html#a75d1187d2819241e7b25bca97d5da7d3">00127</a> <span class="keywordtype">void</span> <a class="code" href="vx__tutorial__image__histogram_8c.html#a75d1187d2819241e7b25bca97d5da7d3" title="Tutorial Entry Point.">vx_tutorial_image_histogram</a>()
<a name="l00128"></a>00128 {
<a name="l00136"></a>00136     vx_context context;
<a name="l00137"></a>00137     vx_image in_image = NULL, out_image = NULL;
<a name="l00138"></a>00138     vx_distribution histogram = NULL;
<a name="l00140"></a>00140     uint32_t num_bins = 256;
<a name="l00141"></a>00141     uint32_t histogram_image_width  = 256;
<a name="l00142"></a>00142     uint32_t histogram_image_height = 128;
<a name="l00143"></a>00143     vx_node node0 = NULL;
<a name="l00144"></a>00144     vx_graph graph = NULL;
<a name="l00145"></a>00145     vx_status status;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147     printf(<span class="stringliteral">&quot; vx_tutorial_image_histogram: Tutorial Started !!! \n&quot;</span>);
<a name="l00148"></a>00148 
<a name="l00156"></a>00156     context = vxCreateContext();
<a name="l00159"></a>00159     printf(<span class="stringliteral">&quot; Loading file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>);
<a name="l00160"></a>00160 
<a name="l00166"></a>00166     graph = vxCreateGraph(context);
<a name="l00168"></a>00168     vxSetReferenceName((vx_reference)graph, <span class="stringliteral">&quot;MY_GRAPH&quot;</span>);
<a name="l00169"></a>00169 
<a name="l00177"></a>00177     in_image = <a class="code" href="utility_8h.html#af8e9cbbd49ab0dec7850267224548cd6" title="Create a image data object given BMP filename as input.">create_image_from_file</a>(context, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>, vx_true_e);
<a name="l00180"></a>00180     vxSetReferenceName((vx_reference)in_image, <span class="stringliteral">&quot;INPUT&quot;</span>);
<a name="l00188"></a>00188     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(in_image);
<a name="l00197"></a>00197     histogram = vxCreateDistribution(context, num_bins, 0, 256);
<a name="l00199"></a>00199     vxSetReferenceName((vx_reference)histogram, <span class="stringliteral">&quot;HISTOGRAM&quot;</span>);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201     {
<a name="l00202"></a>00202         vx_reference refs[] = {(vx_reference)in_image, (vx_reference)histogram};
<a name="l00203"></a>00203 
<a name="l00209"></a>00209         node0 = tivxCreateNodeByKernelEnum(graph,
<a name="l00210"></a>00210                     VX_KERNEL_HISTOGRAM,
<a name="l00211"></a>00211                     refs, <span class="keyword">sizeof</span>(refs)/<span class="keyword">sizeof</span>(refs[0])
<a name="l00212"></a>00212                     );
<a name="l00214"></a>00214         vxSetReferenceName((vx_reference)node0, <span class="stringliteral">&quot;HISTOGRAM&quot;</span>);
<a name="l00215"></a>00215     }
<a name="l00216"></a>00216 
<a name="l00224"></a>00224     status = vxVerifyGraph(graph);
<a name="l00234"></a>00234     <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(graph);
<a name="l00243"></a>00243     <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node0);
<a name="l00246"></a>00246     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00247"></a>00247     {
<a name="l00248"></a>00248         printf(<span class="stringliteral">&quot; Executing graph ...\n&quot;</span>);
<a name="l00249"></a>00249 
<a name="l00258"></a>00258         vxScheduleGraph(graph);
<a name="l00267"></a>00267         vxWaitGraph(graph);
<a name="l00270"></a>00270         printf(<span class="stringliteral">&quot; Executing graph ... Done !!!\n&quot;</span>);
<a name="l00271"></a>00271 
<a name="l00279"></a>00279         <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(graph);
<a name="l00288"></a>00288         <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node0);
<a name="l00291"></a>00291         out_image = <a class="code" href="vx__tutorial__image__histogram_8c.html#ae444e5c191e73db9a523c43b76a7478c" title="Convert distribution given as input to image.">convert_distribution_to_image</a>(histogram,
<a name="l00292"></a>00292                         histogram_image_width,
<a name="l00293"></a>00293                         histogram_image_height);
<a name="l00294"></a>00294 
<a name="l00295"></a>00295         vxSetReferenceName((vx_reference)out_image, <span class="stringliteral">&quot;HISTOGRAM_IMAGE&quot;</span>);
<a name="l00303"></a>00303         <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(out_image);
<a name="l00306"></a>00306         printf(<span class="stringliteral">&quot; Saving to file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>);
<a name="l00315"></a>00315         <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>, out_image);
<a name="l00324"></a>00324         vxReleaseImage(&amp;out_image);
<a name="l00326"></a>00326     }
<a name="l00327"></a>00327 
<a name="l00334"></a>00334     vxReleaseImage(&amp;in_image);
<a name="l00343"></a>00343     vxReleaseDistribution(&amp;histogram);
<a name="l00352"></a>00352     vxReleaseNode(&amp;node0);
<a name="l00361"></a>00361     vxReleaseGraph(&amp;graph);
<a name="l00372"></a>00372     vxReleaseContext(&amp;context);
<a name="l00375"></a>00375     printf(<span class="stringliteral">&quot; vx_tutorial_image_histogram: Tutorial Done !!! \n&quot;</span>);
<a name="l00376"></a>00376     printf(<span class="stringliteral">&quot; \n&quot;</span>);
<a name="l00377"></a>00377 }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 <span class="preprocessor">#define MAX_BINS    (256u)</span>
<a name="l00380"></a>00380 <span class="preprocessor"></span>
<a name="l00390"></a><a class="code" href="vx__tutorial__image__histogram_8c.html#ae444e5c191e73db9a523c43b76a7478c">00390</a> vx_image <a class="code" href="vx__tutorial__image__histogram_8c.html#ae444e5c191e73db9a523c43b76a7478c" title="Convert distribution given as input to image.">convert_distribution_to_image</a>(vx_distribution distribution,
<a name="l00391"></a>00391             uint32_t width, uint32_t height)
<a name="l00392"></a>00392 {
<a name="l00393"></a>00393     vx_image image;
<a name="l00394"></a>00394     vx_context context;
<a name="l00395"></a>00395     vx_status status;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397     context = vxGetContext((vx_reference)distribution);
<a name="l00398"></a>00398 
<a name="l00406"></a>00406     image = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
<a name="l00409"></a>00409     <span class="keywordflow">if</span>(vxGetStatus((vx_reference)image)==VX_SUCCESS)
<a name="l00410"></a>00410     {
<a name="l00411"></a>00411         vx_size num_bins;
<a name="l00412"></a>00412 
<a name="l00419"></a>00419         status = vxQueryDistribution(distribution, VX_DISTRIBUTION_BINS, &amp;num_bins, <span class="keyword">sizeof</span>(vx_size));
<a name="l00422"></a>00422         <span class="keywordflow">if</span>(status == VX_SUCCESS &amp;&amp; num_bins &lt;=  MAX_BINS)
<a name="l00423"></a>00423         {
<a name="l00424"></a>00424             uint32_t histogram_data[MAX_BINS] = {0};
<a name="l00425"></a>00425             uint32_t i, max;
<a name="l00426"></a>00426 
<a name="l00433"></a>00433             vxCopyDistribution(distribution,
<a name="l00434"></a>00434                 (<span class="keywordtype">void</span>**)&amp;histogram_data[0],
<a name="l00435"></a>00435                 VX_READ_ONLY,
<a name="l00436"></a>00436                 VX_MEMORY_TYPE_HOST);
<a name="l00439"></a>00439             <span class="comment">/* normalize bins */</span>
<a name="l00440"></a>00440             max = 0;
<a name="l00441"></a>00441             <span class="keywordflow">for</span>(i=0; i&lt;num_bins; i++)
<a name="l00442"></a>00442             {
<a name="l00443"></a>00443                 <span class="keywordflow">if</span>(histogram_data[i] &gt; max )
<a name="l00444"></a>00444                     max = histogram_data[i];
<a name="l00445"></a>00445             }
<a name="l00446"></a>00446             <span class="comment">/* scale to image height */</span>
<a name="l00447"></a>00447             <span class="keywordflow">for</span>(i=0; i&lt;num_bins; i++)
<a name="l00448"></a>00448             {
<a name="l00449"></a>00449                 histogram_data[i] = (uint32_t)(((<span class="keywordtype">float</span>)histogram_data[i]/max)*height + 0.5);
<a name="l00450"></a>00450                 <span class="keywordflow">if</span>(histogram_data[i]&gt;height)
<a name="l00451"></a>00451                     histogram_data[i] = height;
<a name="l00452"></a>00452             }
<a name="l00453"></a>00453 
<a name="l00454"></a>00454             {
<a name="l00455"></a>00455                 uint8_t *data_ptr = NULL;
<a name="l00456"></a>00456                 vx_rectangle_t rect = { 0, 0, width, height};
<a name="l00457"></a>00457                 vx_map_id map_id;
<a name="l00458"></a>00458                 vx_imagepatch_addressing_t image_addr;
<a name="l00459"></a>00459 
<a name="l00466"></a>00466                 status = vxMapImagePatch(image,
<a name="l00467"></a>00467                             &amp;rect,
<a name="l00468"></a>00468                             0,
<a name="l00469"></a>00469                             &amp;map_id,
<a name="l00470"></a>00470                             &amp;image_addr,
<a name="l00471"></a>00471                             (<span class="keywordtype">void</span>**)&amp;data_ptr,
<a name="l00472"></a>00472                             VX_WRITE_ONLY, VX_MEMORY_TYPE_HOST, VX_NOGAP_X);
<a name="l00476"></a>00476                 <span class="keywordflow">if</span>(status==VX_SUCCESS &amp;&amp; data_ptr!=NULL)
<a name="l00477"></a>00477                 {
<a name="l00478"></a>00478                     uint32_t i, j, k, bin_width;
<a name="l00479"></a>00479                     uint8_t *addr0 = NULL, *addr1 = NULL;
<a name="l00480"></a>00480 
<a name="l00481"></a>00481                     bin_width = width/num_bins;
<a name="l00482"></a>00482 
<a name="l00483"></a>00483                     <span class="keywordflow">for</span>(i=0; i&lt;num_bins; i++)
<a name="l00484"></a>00484                     {
<a name="l00485"></a>00485                         addr0 = data_ptr + i*bin_width;
<a name="l00486"></a>00486 
<a name="l00487"></a>00487                         <span class="keywordflow">for</span>(j=0; j&lt;height-histogram_data[i]; j++)
<a name="l00488"></a>00488                         {
<a name="l00489"></a>00489                             addr1 = addr0 + j*image_addr.stride_y;
<a name="l00490"></a>00490                             <span class="keywordflow">for</span>(k=0; k&lt;bin_width; k++)
<a name="l00491"></a>00491                             {
<a name="l00492"></a>00492                                 addr1[k] = 0xFF;
<a name="l00493"></a>00493                             }
<a name="l00494"></a>00494                         }
<a name="l00495"></a>00495 
<a name="l00496"></a>00496                         addr0 = data_ptr + j*image_addr.stride_y + i*bin_width;
<a name="l00497"></a>00497 
<a name="l00498"></a>00498                         <span class="keywordflow">for</span>(j=0; j&lt;histogram_data[i]; j++)
<a name="l00499"></a>00499                         {
<a name="l00500"></a>00500                             addr1 = addr0 + j*image_addr.stride_y;
<a name="l00501"></a>00501                             <span class="keywordflow">for</span>(k=0; k&lt;bin_width; k++)
<a name="l00502"></a>00502                             {
<a name="l00503"></a>00503                                 addr1[k] = 0x0;
<a name="l00504"></a>00504                             }
<a name="l00505"></a>00505                         }
<a name="l00506"></a>00506                     }
<a name="l00511"></a>00511                     vxUnmapImagePatch(image, map_id);
<a name="l00513"></a>00513                 }
<a name="l00514"></a>00514             }
<a name="l00515"></a>00515         }
<a name="l00516"></a>00516         <span class="keywordflow">else</span>
<a name="l00517"></a>00517         {
<a name="l00518"></a>00518             <span class="comment">/* more bins than allocated memory */</span>
<a name="l00525"></a>00525             vxReleaseImage(&amp;image);
<a name="l00527"></a>00527         }
<a name="l00528"></a>00528     }
<a name="l00529"></a>00529 
<a name="l00530"></a>00530     <span class="keywordflow">return</span> image;
<a name="l00531"></a>00531 }
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
